diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.c gdm-2.28.2/gui/simple-greeter/gdm-user-manager.c
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.c	2010-01-22 11:17:50.731384714 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user-manager.c	2010-01-24 16:57:33.169124287 -0500
@@ -1,10 +1,10 @@
 /* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
  *
- * Copyright (C) 2007-2008 William Jon McCann <mccann@jhu.edu>
+ * Copyright (C) 2009-2010 Red Hat, Inc.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
+ * the Free Software Foundation; either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
@@ -16,6 +16,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  *
+ * Written by: Matthias Clasen <mclasen@redhat.com>
  */
 
 #include "config.h"
@@ -29,6 +30,7 @@
 #include <errno.h>
 #include <sys/stat.h>
 #include <sys/types.h>
+#include <pwd.h>
 
 #ifdef HAVE_PATHS_H
 #include <paths.h>
@@ -40,91 +42,23 @@
 #include <glib-object.h>
 #include <gio/gio.h>
 
-#include <dbus/dbus.h>
-#include <dbus/dbus-glib.h>
-#include <dbus/dbus-glib-lowlevel.h>
-
-#include "gdm-user-manager.h"
-#include "gdm-user-private.h"
-
-#define GDM_USER_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GDM_TYPE_USER_MANAGER, GdmUserManagerPrivate))
-
 #define CK_NAME      "org.freedesktop.ConsoleKit"
 #define CK_PATH      "/org/freedesktop/ConsoleKit"
 #define CK_INTERFACE "org.freedesktop.ConsoleKit"
-
 #define CK_MANAGER_PATH      "/org/freedesktop/ConsoleKit/Manager"
 #define CK_MANAGER_INTERFACE "org.freedesktop.ConsoleKit.Manager"
 #define CK_SEAT_INTERFACE    "org.freedesktop.ConsoleKit.Seat"
 #define CK_SESSION_INTERFACE "org.freedesktop.ConsoleKit.Session"
 
-/* Prefs Defaults */
-#define DEFAULT_ALLOW_ROOT      TRUE
-#define DEFAULT_MAX_ICON_SIZE   128
-#define DEFAULT_USER_MAX_FILE   65536
-
-#ifdef __sun
-#define DEFAULT_MINIMAL_UID     100
-#else
-#define DEFAULT_MINIMAL_UID     500
-#endif
-
-#ifndef _PATH_SHELLS
-#define _PATH_SHELLS    "/etc/shells"
-#endif
-#define PATH_PASSWD     "/etc/passwd"
-
-#define DEFAULT_GLOBAL_FACE_DIR DATADIR "/faces"
-#define DEFAULT_USER_ICON       "stock_person"
-#define DEFAULT_EXCLUDE         { "bin",        \
-                                  "root",       \
-                                  "daemon",     \
-                                  "adm",        \
-                                  "lp",         \
-                                  "sync",       \
-                                  "shutdown",   \
-                                  "halt",       \
-                                  "mail",       \
-                                  "news",       \
-                                  "uucp",       \
-                                  "operator",   \
-                                  "nobody",     \
-                                  "nobody4",    \
-                                  "noaccess",   \
-                                  GDM_USERNAME, \
-                                  "postgres",   \
-                                  "pvm",        \
-                                  "rpm",        \
-                                  "nfsnobody",  \
-                                  "pcap",       \
-                                  NULL }
-
-struct GdmUserManagerPrivate
-{
-        GHashTable            *users;
-        GHashTable            *sessions;
-        GHashTable            *exclusions;
-        GHashTable            *shells;
-        DBusGConnection       *connection;
-        DBusGProxy            *seat_proxy;
-        char                  *seat_id;
-
-        GFileMonitor          *passwd_monitor;
-        GFileMonitor          *shells_monitor;
-
-        guint                  reload_id;
-        guint                  ck_history_id;
-
-        guint8                 users_dirty : 1;
-};
+#include "gdm-user-manager.h"
+#include "gdm-user-private.h"
 
 enum {
-        LOADING_USERS,
         USERS_LOADED,
         USER_ADDED,
         USER_REMOVED,
+        USER_CHANGED,
         USER_IS_LOGGED_IN_CHANGED,
-        USER_LOGIN_FREQUENCY_CHANGED,
         LAST_SIGNAL
 };
 
@@ -132,356 +66,285 @@
 
 static void     gdm_user_manager_class_init (GdmUserManagerClass *klass);
 static void     gdm_user_manager_init       (GdmUserManager      *user_manager);
-static void     gdm_user_manager_finalize   (GObject             *object);
+static void     gdm_user_manager_finalize   (GObject            *object);
 
 static gpointer user_manager_object = NULL;
 
 G_DEFINE_TYPE (GdmUserManager, gdm_user_manager, G_TYPE_OBJECT)
 
-GQuark
-gdm_user_manager_error_quark (void)
+static void
+gdm_user_manager_class_init (GdmUserManagerClass *klass)
 {
-        static GQuark ret = 0;
-        if (ret == 0) {
-                ret = g_quark_from_static_string ("gdm_user_manager_error");
-        }
+        GObjectClass   *object_class = G_OBJECT_CLASS (klass);
 
-        return ret;
+        object_class->finalize = gdm_user_manager_finalize;
+
+       signals [USERS_LOADED] =
+                g_signal_new ("users-loaded",
+                              G_TYPE_FROM_CLASS (klass),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GdmUserManagerClass, users_loaded),
+                              NULL, NULL,
+                              g_cclosure_marshal_VOID__VOID,
+                              G_TYPE_NONE, 0);
+
+        signals [USER_ADDED] =
+                g_signal_new ("user-added",
+                              G_TYPE_FROM_CLASS (klass),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GdmUserManagerClass, user_added),
+                              NULL, NULL,
+                              g_cclosure_marshal_VOID__OBJECT,
+                              G_TYPE_NONE, 1, GDM_TYPE_USER);
+        signals [USER_REMOVED] =
+                g_signal_new ("user-removed",
+                              G_TYPE_FROM_CLASS (klass),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GdmUserManagerClass, user_removed),
+                              NULL, NULL,
+                              g_cclosure_marshal_VOID__OBJECT,
+                              G_TYPE_NONE, 1, GDM_TYPE_USER);
+        signals [USER_CHANGED] =
+                g_signal_new ("user-changed",
+                              G_TYPE_FROM_CLASS (klass),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GdmUserManagerClass, user_changed),
+                              NULL, NULL,
+                              g_cclosure_marshal_VOID__OBJECT,
+                              G_TYPE_NONE, 1, GDM_TYPE_USER);
+        signals [USER_IS_LOGGED_IN_CHANGED] =
+                g_signal_new ("user-is-logged-in-changed",
+                              G_TYPE_FROM_CLASS (klass),
+                              G_SIGNAL_RUN_LAST,
+                              G_STRUCT_OFFSET (GdmUserManagerClass, user_is_logged_in_changed),
+                              NULL, NULL,
+                              g_cclosure_marshal_VOID__OBJECT,
+                              G_TYPE_NONE, 1, GDM_TYPE_USER);
 }
 
 static gboolean
-start_new_login_session (GdmUserManager *manager)
+match_real_name_hrfunc (gpointer key,
+                        gpointer value,
+                        gpointer user)
 {
-        GError  *error;
-        gboolean res;
+        return (value != user && g_strcmp0 (gdm_user_get_real_name (user), gdm_user_get_real_name (value)) == 0);
+}
 
-        res = g_spawn_command_line_async ("gdmflexiserver -s", &error);
-        if (! res) {
-                if (error != NULL) {
-                        g_warning ("Unable to start new login: %s", error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("Unable to start new login");
-                }
+static void
+user_changed_handler (GdmUser        *user,
+                      GdmUserManager *manager)
+{
+        GdmUser *dup;
+
+        dup = g_hash_table_find (manager->user_by_object_path,
+                                 match_real_name_hrfunc,
+                                 user);
+        if (dup != NULL) {
+                _gdm_user_show_full_display_name (user);
+                _gdm_user_show_full_display_name (dup);
+        }
+        else {
+                _gdm_user_show_short_display_name (user);
         }
 
-        return res;
+        g_signal_emit (manager, signals[USER_CHANGED], 0, user);
 }
 
-/* needs to stay in sync with gdm-slave */
 static char *
-_get_primary_user_session_id (GdmUserManager *manager,
-                              GdmUser        *user)
+get_seat_id_for_session (DBusGConnection *connection,
+                         const char      *session_id)
 {
-        gboolean    res;
-        gboolean    can_activate_sessions;
-        GError     *error;
-        GList      *sessions;
-        GList      *l;
-        char       *primary_ssid;
-
-        if (manager->priv->seat_id == NULL || manager->priv->seat_id[0] == '\0') {
-                g_debug ("GdmUserManager: display seat id is not set; can't switch sessions");
-                return NULL;
-        }
+        DBusGProxy      *proxy;
+        GError          *error;
+        char            *seat_id;
+        gboolean         res;
 
-        primary_ssid = NULL;
-        sessions = NULL;
+        proxy = NULL;
+        seat_id = NULL;
 
-        g_debug ("GdmUserManager: checking if seat can activate sessions");
+        proxy = dbus_g_proxy_new_for_name (connection,
+                                           CK_NAME,
+                                           session_id,
+                                           CK_SESSION_INTERFACE);
+        if (proxy == NULL) {
+                g_warning ("Failed to connect to the ConsoleKit session object");
+                goto out;
+        }
 
         error = NULL;
-        res = dbus_g_proxy_call (manager->priv->seat_proxy,
-                                 "CanActivateSessions",
+        res = dbus_g_proxy_call (proxy,
+                                 "GetSeatId",
                                  &error,
                                  G_TYPE_INVALID,
-                                 G_TYPE_BOOLEAN, &can_activate_sessions,
+                                 DBUS_TYPE_G_OBJECT_PATH, &seat_id,
                                  G_TYPE_INVALID);
         if (! res) {
                 if (error != NULL) {
-                        g_warning ("unable to determine if seat can activate sessions: %s",
-                                   error->message);
+                        g_debug ("Failed to identify the current seat: %s", error->message);
                         g_error_free (error);
                 } else {
-                        g_warning ("unable to determine if seat can activate sessions");
-                }
-                goto out;
-        }
-
-        if (! can_activate_sessions) {
-                g_debug ("GdmUserManager: seat is unable to activate sessions");
-                goto out;
-        }
-
-        sessions = gdm_user_get_sessions (user);
-        if (sessions == NULL) {
-                g_warning ("unable to determine sessions for user: %s",
-                           gdm_user_get_user_name (user));
-                goto out;
-        }
-
-        for (l = sessions; l != NULL; l = l->next) {
-                const char *ssid;
-
-                ssid = l->data;
-
-                /* FIXME: better way to choose? */
-                if (ssid != NULL) {
-                        primary_ssid = g_strdup (ssid);
-                        break;
-                }
-        }
-
- out:
-
-        return primary_ssid;
-}
-
-static gboolean
-activate_session_id (GdmUserManager *manager,
-                     const char     *seat_id,
-                     const char     *session_id)
-{
-        DBusError    local_error;
-        DBusMessage *message;
-        DBusMessage *reply;
-        gboolean     ret;
-
-        ret = FALSE;
-        reply = NULL;
-
-        dbus_error_init (&local_error);
-        message = dbus_message_new_method_call ("org.freedesktop.ConsoleKit",
-                                                seat_id,
-                                                "org.freedesktop.ConsoleKit.Seat",
-                                                "ActivateSession");
-        if (message == NULL) {
-                goto out;
-        }
-
-        if (! dbus_message_append_args (message,
-                                        DBUS_TYPE_OBJECT_PATH, &session_id,
-                                        DBUS_TYPE_INVALID)) {
-                goto out;
-        }
-
-
-        dbus_error_init (&local_error);
-        reply = dbus_connection_send_with_reply_and_block (dbus_g_connection_get_connection (manager->priv->connection),
-                                                           message,
-                                                           -1,
-                                                           &local_error);
-        if (reply == NULL) {
-                if (dbus_error_is_set (&local_error)) {
-                        g_warning ("Unable to activate session: %s", local_error.message);
-                        dbus_error_free (&local_error);
-                        goto out;
+                        g_debug ("Failed to identify the current seat");
                 }
         }
-
-        ret = TRUE;
  out:
-        if (message != NULL) {
-                dbus_message_unref (message);
-        }
-        if (reply != NULL) {
-                dbus_message_unref (reply);
+        if (proxy != NULL) {
+                g_object_unref (proxy);
         }
-
-        return ret;
+        return seat_id;
 }
 
-static gboolean
-session_is_login_window (GdmUserManager *manager,
-                         const char     *session_id)
+static char *
+get_x11_display_for_session (DBusGConnection *connection,
+                             const char      *session_id)
 {
         DBusGProxy      *proxy;
         GError          *error;
+        char            *x11_display;
         gboolean         res;
-        gboolean         ret;
-        char            *session_type;
 
-        ret = FALSE;
+        proxy = NULL;
+        x11_display = NULL;
 
-        proxy = dbus_g_proxy_new_for_name (manager->priv->connection,
+        proxy = dbus_g_proxy_new_for_name (connection,
                                            CK_NAME,
                                            session_id,
                                            CK_SESSION_INTERFACE);
         if (proxy == NULL) {
-                g_warning ("Failed to connect to the ConsoleKit seat object");
+                g_warning ("Failed to connect to the ConsoleKit session object");
                 goto out;
         }
-
-        session_type = NULL;
         error = NULL;
         res = dbus_g_proxy_call (proxy,
-                                 "GetSessionType",
+                                 "GetX11Display",
                                  &error,
                                  G_TYPE_INVALID,
-                                 G_TYPE_STRING, &session_type,
+                                 G_TYPE_STRING, &x11_display,
                                  G_TYPE_INVALID);
         if (! res) {
                 if (error != NULL) {
-                        g_debug ("Failed to identify the session type: %s", error->message);
+                        g_debug ("Failed to identify the x11 display: %s", error->message);
                         g_error_free (error);
                 } else {
-                        g_debug ("Failed to identify the session type");
+                        g_debug ("Failed to identify the x11 display");
                 }
-                goto out;
-        }
-
-        if (session_type == NULL || session_type[0] == '\0' || strcmp (session_type, "LoginWindow") != 0) {
-                goto out;
         }
-
-        ret = TRUE;
-
  out:
         if (proxy != NULL) {
                 g_object_unref (proxy);
         }
 
-        return ret;
+        return x11_display;
 }
 
-static char *
-_get_login_window_session_id (GdmUserManager *manager)
+static gboolean
+maybe_add_session_for_user (GdmUserManager *manager,
+                            GdmUser        *user,
+                            const char     *ssid)
 {
-        gboolean    res;
-        gboolean    can_activate_sessions;
-        GError     *error;
-        GPtrArray  *sessions;
-        char       *primary_ssid;
-        int         i;
+        char    *sid;
+        char    *x11_display;
+        gboolean ret;
 
-        if (manager->priv->seat_id == NULL || manager->priv->seat_id[0] == '\0') {
-                g_debug ("GdmUserManager: display seat id is not set; can't switch sessions");
-                return NULL;
-        }
+        ret = FALSE;
+        sid = NULL;
+        x11_display = NULL;
 
-        primary_ssid = NULL;
-        sessions = NULL;
+        /* skip if on another seat */
+        sid = get_seat_id_for_session (manager->bus, ssid);
+        if (sid == NULL
+            || manager->seat_id == NULL
+            || strcmp (sid, manager->seat_id) != 0) {
+                g_debug ("GdmUserManager: not adding session on other seat: %s", ssid);
+                goto out;
+        }
 
-        g_debug ("GdmSlave: checking if seat can activate sessions");
+        /* skip if doesn't have an x11 display */
+        x11_display = get_x11_display_for_session (manager->bus, ssid);
+        if (x11_display == NULL || x11_display[0] == '\0') {
+                g_debug ("GdmUserManager: not adding session without a x11 display: %s", ssid);
+                goto out;
+        }
 
-        error = NULL;
-        res = dbus_g_proxy_call (manager->priv->seat_proxy,
-                                 "CanActivateSessions",
-                                 &error,
-                                 G_TYPE_INVALID,
-                                 G_TYPE_BOOLEAN, &can_activate_sessions,
-                                 G_TYPE_INVALID);
-        if (! res) {
-                if (error != NULL) {
-                        g_warning ("unable to determine if seat can activate sessions: %s",
-                                   error->message);
-                        g_error_free (error);
-                } else {
-                        g_warning ("unable to determine if seat can activate sessions");
-                }
+#if 0
+        if (g_hash_table_lookup (manager->exclusions, gdm_user_get_user_name (user))) {
+                g_debug ("GdmUserManager: excluding user '%s'", gdm_user_get_user_name (user));
                 goto out;
         }
+#endif
+
+        g_hash_table_insert (manager->sessions,
+                             g_strdup (ssid),
+                             g_strdup (gdm_user_get_user_name (user)));
+
+        _gdm_user_add_session (user, ssid);
+        g_debug ("GdmUserManager: added session for user: %s", gdm_user_get_user_name (user));
+
+        ret = TRUE;
+
+ out:
+        g_free (sid);
+        g_free (x11_display);
+
+        return ret;
+}
+
+static void
+add_sessions_for_user (GdmUserManager *manager,
+                       GdmUser        *user)
+{
+        DBusGProxy      *proxy;
+        GError          *error;
+        gboolean         res;
+        guint32          uid;
+        GPtrArray       *sessions;
+        int              i;
 
-        if (! can_activate_sessions) {
-                g_debug ("GdmSlave: seat is unable to activate sessions");
+        proxy = dbus_g_proxy_new_for_name (manager->bus,
+                                           CK_NAME,
+                                           CK_MANAGER_PATH,
+                                           CK_MANAGER_INTERFACE);
+        if (proxy == NULL) {
+                g_warning ("Failed to connect to the ConsoleKit manager object");
                 goto out;
         }
+        uid = gdm_user_get_uid (user);
+
+        g_debug ("Getting list of sessions for user %u", uid);
 
         error = NULL;
-        res = dbus_g_proxy_call (manager->priv->seat_proxy,
-                                 "GetSessions",
+        res = dbus_g_proxy_call (proxy,
+                                 "GetSessionsForUnixUser",
                                  &error,
+                                 G_TYPE_UINT, uid,
                                  G_TYPE_INVALID,
-                                 dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH), &sessions,
+                                 dbus_g_type_get_collection ("GPtrArray", DBUS_TYPE_G_OBJECT_PATH),
+                                 &sessions,
                                  G_TYPE_INVALID);
         if (! res) {
                 if (error != NULL) {
-                        g_warning ("unable to determine sessions for user: %s",
-                                   error->message);
+                        g_debug ("Failed to find sessions for user: %s", error->message);
                         g_error_free (error);
                 } else {
-                        g_warning ("unable to determine sessions for user");
+                        g_debug ("Failed to find sessions for user");
                 }
                 goto out;
         }
 
+        g_debug ("Found %d sessions for user %s", sessions->len, gdm_user_get_user_name (user));
+
         for (i = 0; i < sessions->len; i++) {
                 char *ssid;
 
                 ssid = g_ptr_array_index (sessions, i);
-
-                if (session_is_login_window (manager, ssid)) {
-                        primary_ssid = g_strdup (ssid);
-                        break;
-                }
+                maybe_add_session_for_user (manager, user, ssid);
         }
+
         g_ptr_array_foreach (sessions, (GFunc)g_free, NULL);
         g_ptr_array_free (sessions, TRUE);
-
  out:
-
-        return primary_ssid;
-}
-
-gboolean
-gdm_user_manager_goto_login_session (GdmUserManager *manager)
-{
-        gboolean ret;
-        gboolean res;
-        char    *ssid;
-
-        g_return_val_if_fail (GDM_IS_USER_MANAGER (manager), FALSE);
-
-        ret = FALSE;
-
-        /* First look for any existing LoginWindow sessions on the seat.
-           If none are found, create a new one. */
-
-        ssid = _get_login_window_session_id (manager);
-        if (ssid != NULL) {
-                res = activate_session_id (manager, manager->priv->seat_id, ssid);
-                if (res) {
-                        ret = TRUE;
-                }
-        }
-
-        if (! ret) {
-                res = start_new_login_session (manager);
-                if (res) {
-                        ret = TRUE;
-                }
-        }
-
-        return ret;
-}
-
-gboolean
-gdm_user_manager_activate_user_session (GdmUserManager *manager,
-                                        GdmUser        *user)
-{
-        gboolean ret;
-        char    *ssid;
-        gboolean res;
-
-        g_return_val_if_fail (GDM_IS_USER_MANAGER (manager), FALSE);
-        g_return_val_if_fail (GDM_IS_USER (user), FALSE);
-
-        ret = FALSE;
-
-        ssid = _get_primary_user_session_id (manager, user);
-        if (ssid == NULL) {
-                goto out;
-        }
-
-        res = activate_session_id (manager, manager->priv->seat_id, ssid);
-        if (! res) {
-                g_debug ("GdmUserManager: unable to activate session: %s", ssid);
-                goto out;
-        }
-
-        ret = TRUE;
- out:
-        return ret;
+        if (proxy != NULL) {
+                g_object_unref (proxy);
+        }
 }
 
 static void
